import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { OaAppField, OaAppFieldParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询应用参数
 */
export async function pageOaAppField(params: OaAppFieldParam) {
  const res = await request.get<ApiResult<PageResult<OaAppField>>>(
    MODULES_API_URL + '/oa/oa-app-field/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询应用参数列表
 */
export async function listOaAppField(params?: OaAppFieldParam) {
  const res = await request.get<ApiResult<OaAppField[]>>(
    MODULES_API_URL + '/oa/oa-app-field',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加应用参数
 */
export async function addOaAppField(data: OaAppField) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改应用参数
 */
export async function updateOaAppField(data: OaAppField) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除应用参数
 */
export async function removeOaAppField(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-field/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除应用参数
 */
export async function removeBatchOaAppField(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-field/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询应用参数
 */
export async function getOaAppField(id: number) {
  const res = await request.get<ApiResult<OaAppField>>(
    MODULES_API_URL + '/oa/oa-app-field/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
